/*****************************************************************/
/*
		C de Cerca 4
		Recursos: WIND y ALRT
		Rafael Escot - Enric Herrera
		BlauSoft S.L. para MacFormat Espaa - 1996
					
		La descripcin del cdigo y la informacin sobre cmo preparar
		el entorno de programacin y generar estos programas, est contenida
		en el ejemplar de MacFormat que los acompaa.

*/
/*****************************************************************/



/*
LA TOOLBOX Y LOS FICHEROS 'UNIVERSAL HEADERS'
==============================================
La Toolbox es una coleccin de funciones escritas por Apple
que han sido ya compiladas y colocadas en los chips de ROM de cada
Mac. 
Para poder emplear en nuestros programas una de dichas funciones,
debemos informar al compilador acerca de los posibles parmetros
y valores de salida requeridos.
En otras palabras, el compilador necesita el prototipo de la funcin
existente en la Toolbox de forma que pueda verificar que el uso que de
ella hagamos en nuestro programa sea correcto.
Los ficheros APPLE UNIVERSAL HEADERS proporcionados por Apple no
son ms que ficheros de texto conteniendo los prototipos de cada una de
las funciones de la Toolbox.

NOTA: Slo para los ms curiosos: En la carpeta que contiene el compilador,
veris una carpeta llamada 'MacOS Support' y en su interior una carpeta
llamada 'Headers' y dentro de ella una carpeta llamada
'Universal Headers', que contiene todos los ficheros creados por Apple.
*/



/* 
COMO DIFERENCIAR FUNCIONES PROPIAS Y DE LA TOOLBOX
===================================================
A las funciones creadas por nosotros para este programa (y que por lo
tanto no pertenecen a la Toolbox) les hemos dado nombres que comienzan
por las iniciales MF. Por ejemplo, MF_PlaySnd(), MF_RandomColor() etc...
Todas las restantes funciones que aparecen empleadas en el cdigo, SON
FUNCIONES PERTENECIENTES A LA TOOLBOX DE APPLE.
(Una excepcin: La funcin main() la hemos creado nosotros pero su nombre
no puede ser otro que main(), por convencin)



/****************************************************************	*/
/* PROTOTIPOS	DE LAS FUNCIONES QUE HEMOS CREADO									 	*/
/* PARA NUESTRO PROGRAMA																					*/ 
/****************************************************************	*/
void		main(void);				/* Esta funcin NO puede tener otro nombre */
void		MF_InitToolbox 		(void);
void 		MF_SetupMenus			(void);
void 		MF_AbreMiVentana	(void);
void 		MF_EscribeTexto		(void);
void 		MF_bucle_principal(void);
void 		MF_MenuBar				(long algoSeleccionado);
void 		MF_Update					(WindowPtr ventana_a_refrescar);



/****************************************************************	*/
/* CONSTANTES Y VARIABLES GLOBALES									 							*/
/* DE USO GENERAL																									*/ 
/****************************************************************	*/
Boolean gAcabarProg = false; /* Una variable global. 
																Como siempre, las variables globales
																las prefijamos con la letra 'g'.
																Cuando gAcabarProg sea = true,
																acabaremos el programa */



/****************************************************************	*/
/* CONSTANTES DEFINIENDO EL NUMERO DE RECURSO	(resource)					*/
/* CORRESPONDIENTE A LA VENTANA DE ALERTA QUE ABRIREMOS						*/
/* CUANDO EL USUARIO SELECCIONE 'Acerca de C de Cerca...'					*/
/* DEL MENU Apple 
/****************************************************************	*/
#define kAlertRsrcID	128	/* N del recurso ALRT */



/****************************************************************	*/
/* CONSTANTES Y VARIABLES GLOBALES									 							*/
/* RELACIONADAS CON LOS MENUS EN NUESTRO PROGRAMA									*/ 
/****************************************************************	*/
#define			kAppleMenuID		128	/* Nuevo recurso MENU para el men Apple */
#define			kArchivoMenuID	129	
#define			kAcercaDe_Item	1
#define			kSalirItem			1

MenuRef			gAppleMenu;
MenuRef			gArchivoMenu;



/****************************************************************	*/
/* CONSTANTES Y VARIABLES GLOBALES									 							*/
/* RELACIONADAS CON LA VENTANA QUE ABRIREMOS											*/ 
/****************************************************************	*/
/* A diferencia de las versiones anteriores, en esta, la ventana que
	abriremos la hemos creado previamente empleando ResEdit y formar
	parte de los recursos de la aplicacin */
	
/*
Una constante con el numero de recurso de la ventana que hemos creado 
empleando ResEdit
*/
#define 		kMiVentanaRsrcID	128	/* N del recurso WIND */

WindowPtr		gMiVentana = nil; /*  Variable de tipo 'pointer'.
																Puntero a una estructura
																de tipo WindowRecord  definida por Apple
																en el fichero UNIVERSAL HEADER Windows.h
																y que corresponder 
																a la ventana que crearemos 
																NOTA slo para curiosos: De hecho,
																una variable WindowPtr apunta a la 
																estructura GrafPort que forma parte de
																la estructura WindowRecord. */

																
																
/*--------------------------------------------------------------------*/
/* A PARTIR DE ESTE PUNTO, APARECE EL CODIGO DE LAS FUNCIONES CREADAS
	ESPECIFICAMENTE PARA ESTE PROGRAMA. */
/*--------------------------------------------------------------------*/



/****************************************************************	*/
/* main()                                     			            	*/
/****************************************************************	*/
/*
	Todos los programas en C poseen una funcin que debe llamarse main.
	(NO PERTENECE A LA TOOLBOX)
	Cuando un programa se pone en marcha, lo hace SIEMPRE ejecutando
	en primer lugar la funcin main().
	Es el punto de entrada a nuestra aplicacin.
	
	Recibe: 	nada
	Que hace: Crea mens y pone una ventana en pantalla etc...
	Salida:  	void (nada)
*/
void	main (void)
{	
	/* Antes de hacer nada, debemos inicializar la Toolbox del Mac 				*/
	/* Como sea que el procedimiento a seguir para inicializar la Toolbox */
	/* es casi siempre el mismo, hemos creado una funcin MF_InitToolbox()*/
	/* que contiene las llamadas estndar de inicializacin */

	MF_InitToolbox();

	/* Ahora debemos preparar y mostrar la barra de men, que contendr */
	/* los mens propios de nuestra aplicacin */
	
	MF_SetupMenus();
	
	/* Ahora empleamos una funcin se encargar de abrir una ventana */
	MF_AbreMiVentana();
	
	/* Una vez abierta la ventana, podemos escribir algo de texto en ella */
	MF_EscribeTexto();
	
	/* Y ya podemos entrar en el bucle principal, que se encargar de
		 recoger e interpretar las acciones del usuario */	
	MF_bucle_principal();
	
	/* Cuando el bucle principal haya terminado, ser porque el usuario
		 desea acabar el programa.
		 Debemos liberar la memoria ocupada por nuestra ventana. */
	DisposeWindow(gMiVentana);
	
	/* Y ya est, al acabarse la funcin main(), el Sistema cerrar
		 nuestra aplicacin de forma automtica */
	
} /* Fin de main() y del programa */



/****************************************************************	*/
/* MF_bucle_principal		                                         	*/
/****************************************************************	*/
/*
	Recibe: 	nada
	Que hace: Entra en un bucle y espera que se produzca una accin (evento)
						Segn cual sea este, reacciona llamando una de las funciones que
						hemos creado en esta demo.
	Salida:  	nada
*/
void MF_bucle_principal(void)
{
	/* Declaramos una variable del tipo EventRecord que llamaremos el_Evento */
	EventRecord	el_Evento; 	
								/* 
								Un EventRecord es una estructura declarada
								por Apple en el fichero UNIVERSAL HEADER
								Events.h y formada por las siguientes
								variables:
														 
							struct EventRecord {
									EventKind				what; 		(qu evento)
									UInt32					message;	(datos del evento)
									UInt32					when;			(cuando se produce)
									Point						where;		(coordenadas del evento)
									EventModifiers	modifiers;(estado de las teclas
																							especiales: CMD, Opt, etc...) 
									};
								*/
	
	WindowPtr	la_ventana;	/* Guardaremos un puntero que nos indicar en que
													 ventana (si es el caso) se ha producido un evento */
	
	
	short	zona_de_la_ventana; /* Tambin guardaremos el cdigo que indica
															 la zona de la ventana en que se produce un evento
															 si es del tipo mouseDown
														*/
														
	
	Boolean	hay_evento;	/* valor de salida de la funcin WaitNextEvent */
											/* Lo ignoraremos en esta demo */
	
	while (gAcabarProg == false)
	/* Mientras la variable global gAcabarProg sea falsa, repetiremos este bucle */
	/* Cuando es usuario seleccione 'Salir' del men Archivo, cambiaremos el */
	/* valor de gAcabarProg a true (cierto) */
	{
		
		hay_evento = WaitNextEvent(everyEvent, &el_Evento, 0L, 0L);
		/* WaitNextEvent es una funcin de la ToolBox que nos proporciona
			 informacin acerca de las posibles acciones del usuario o eventos del
			 Sistema. Para ello, 'llena' de informacin las variables de la estructura
			 EventRecord (el_Evento, en nuestro caso) */ 
		
		switch(el_Evento.what)
		{
			case nullEvent:
					/* Ignoramos eventos nulos (ningn evento).*/
			break;
					
			case keyDown:
			/* Se ha pulsado una tecla. Comprobaremos si tambin se ha pulsado
				 la tecla de CMD y si es as, llamaremos la funcin que responde
				 a la seleccin de opciones de men */
				if(el_Evento.modifiers & cmdKey) /* Tecla de CMD pulsada? */
				{
	       	MF_MenuBar(MenuKey( el_Evento.message & charCodeMask) ) ;
	       }
			break;
					
			case autoKey:
				/* Ignoramos los eventos de repeticin, generados al mantener
					 pulsada una tecla */
			break;
					
			case mouseDown:
			/* clic del ratn en algn sitio...*/
				zona_de_la_ventana = FindWindow(el_Evento.where,&la_ventana);
				switch (zona_de_la_ventana)
				{
					case inDrag:/* clic en la barra de ttulo. Para que el usuario 	*/
											/* pueda arrastrar la ventana, simplemente hemos de	*/
											/* usar la funcin DragWindow() que se encarga del	*/
											/* proceso, hasta que se suelte el botn del ratn 	*/
						DragWindow(la_ventana,el_Evento.where,&qd.screenBits.bounds);
					break;
							
					case inMenuBar: /* clic en la barra de mens */
						MF_MenuBar(MenuSelect(el_Evento.where));
					break;
							
					default:
						/* Ignoramos clics en otras zonas de la ventana */
					break;
				}
			break;
					
			case mouseUp:
			/* ignoraremos los eventos producidos al soltar el botn del ratn */
			break;
				
			case diskEvt:
			/* Tambin ignoraremos los eventos producidos al insertar un disco */
			break;
				
			case updateEvt:
				/*	Una ventana debe ser refrescada. Llamamos la funcin
						MF_Update, pasndole un puntero a la ventana en cuestin.
						La variable message de la estructura EventRecord, contiene
						dicho puntero, pero es necesario forzar (cast) su tipo al
						de WindowPtr */
				la_ventana = (WindowPtr)el_Evento.message;
				MF_Update( la_ventana );
			break;
				
			default:
			/* En cualquier otro caso, ignoramos el evento */
			break;
				
		} /* Fin de switch(el_Evento.what) */
			
	} /* Fin de while (gAcabarProg == false) */
		
		
} /* Fin de la funcin MF_bucle_principal() */



/****************************************************************	*/
/* MF_Update			     				                                  	*/
/****************************************************************	*/
/*
	Esta funcin se emplea cuando MF_bucle_principal ha detectado un evento
	del tipo updateEvt. El sistema lo genera cuando una ventana activa
	es desplazada o cuando una ventana que no era la activa es activada.
	En estos casos, la zona de la ventana que permaneca
	oculta por otras ventanas debe ser refrescada, re-dibujando su contenido.
	El sistema controla todas las ventanas abiertas y genera un evento updateEvt
	cuando alguna zona de una ventana necesita ser refrescada.
	
	Recibe: 	un puntero a la ventana que debe ser refrescada.
	Que hace: Esta demo aprovecha la funcin MF_EscribeTexto(). Cuando la ventana
						necesita refrescarse, simplemente llamamos de nuevo MF_EscribeTexto()
						y la ventana se actualizar.
						
	Salida:  	void (nada)
*/
void MF_Update( WindowPtr ventana_a_refrescar)
{

	GrafPtr  old_port;							/* Declaracin de una variable de tipo
																		 puntero (pointer) a un rea grfica */
	
	GetPort( &old_port );						/* Preservamos el rea grfica actual */
	
	SetPort( ventana_a_refrescar );	/* Cambiamos de rea, seleccionando la
																		correspondiente a la ventana que debe
																		refrescarse */
  
  BeginUpdate( ventana_a_refrescar );
   
    /* Aqui deberamos llamar las funciones adecuadas para re-dibujar los
    	 contenidos de nuestra ventana.  En este caso re-escribimos un texto
    	 en la ventana
    */
    	 
     MF_EscribeTexto();
 			
	EndUpdate( ventana_a_refrescar );

	SetPort( old_port );					/* recuperamos el rea grfica inicial */
	
} /* Fin de MF_Update() */



/****************************************************************	*/
/* MF_MenuBar			     				                                  	*/
/****************************************************************	*/
/*
	Esta funcin reacciona cuando MF_bucle_principal ha detectado que el clic
	del ratn se ha producido en la barra de mens de nuestro programa.
	
	Requiere: Un recurso de tipo ALRT en el fichero CdeCerca_4..rsrc
	Recibe: 	una variable con la informacin del menu e item seleccionados
	Que hace: Acta en funcin de la posible seleccin de un item de alguno
						de nuestros mens.
	Salida:  	void (nada)
*/
void MF_MenuBar(long algoSeleccionado)
{
	short	Que_Menu;
	short	Que_Opcion;
	short dummy;
	Str255 ItemName;
	GrafPtr oldPort;
	
	if(algoSeleccionado != 0L)
	{
		/* algoSeleccionado es un valor de tipo long (4 bytes)
			 que contiene en los 2 bytes superiores el nmero de men seleccionado
			 y en los dos bytes inferiores, el nmero de la opcin seleccionada
			 de dicho men.
			 Para extraer ambos valores, emplearemos una funciones de la Toolbox,
			 HiWord y LoWord que nos devolvern los valores que nos interesan */
			 
		Que_Menu = HiWord(algoSeleccionado); 	/* 2 bytes superiores */
		Que_Opcion = LoWord(algoSeleccionado);/* 2 bytes inferiores */
		
		switch(Que_Menu)
		{
			case kAppleMenuID: 									/* Men Apple (nuevo)									*/
				if(Que_Opcion == kAcercaDe_Item) 	/* Si es la opcin 'Acerca de' 	*/
				{
					/* Empleamos la funcin Alert() de la Toolbox, para que el Sistema
						 abra un cuadro de dilogo que hemos creado previamente usando
						 ResEdit, como recurso de tipo ALRT.
						 La funcin Alert() pasa el control de nuestro programa al Sistema
						 y no nos lo devuelve hasta que el usuario haya cerrado la ventana de
						 alerta
					*/ 
					Alert(kAlertRsrcID,nil); /* Todo parado... */
				}
				else
				/* NO es la opcin 'Acerca de'. Ha de ser algo del men Apple */
				/* Puede ser cualquier cosa... carpetas, aplicaciones, documentos...*/
				{
					/* 1 Obtenemos el nombre del item seleccionado */
					GetItem(gAppleMenu,Que_Opcion, ItemName);
					
					GetPort(&oldPort);
					
					/* 2 Lo abrimos empleando la funcin OpenDeskacc() que */
					/* funcionar sea cual sea el tipo de objeto del men Apple */
					/* seleccionado por el usuario. Podemos ignorar el valor que  */
					/* OpenDeskAcc() devuelve */
					dummy = OpenDeskAcc(ItemName);
					
					SetPort(oldPort);
				}	
			break;
			
			case kArchivoMenuID:								/* Men Archivo 										*/
				switch(Que_Opcion)
				{
					case kSalirItem:								/* Opcin 'Salir' 									*/
						gAcabarProg = true;						/*IMPORTANTE: Cambiamos el valor de
																						la variable global que nos indica
																						que debemos finalizar el programa */
					break;												
						
				} /* Fin de switch(Que_Opcion) */
				
			break;
		} /* Fin de switch(Que_Menu) */
		
		HiliteMenu(0);
		
	} /* Fin de if(algoSeleccionado != 0L) */
	
} /* Fin de funcin MF_MenuBar() */



/****************************************************************	*/
/* MF_InitToolbox 																								*/
/****************************************************************	*/
/*
	Inicializa la Toolbox Macintosh. El orden de llamada a las diversas
	rutinas es significativo! No lo cambie.

	Requiere: nada
	Recibe: 	nada
	Cambia:  	nada en la aplicacin
	Salida:  	nada
*/
void MF_InitToolbox (void)
{
	InitGraf(&qd.thePort);
	InitFonts();
	FlushEvents(everyEvent,0);
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0L);
	InitCursor();
								
} /* Fin de MF_InitToolbox() */



/****************************************************************	*/
/* MF_SetupMenus																									*/
/****************************************************************	*/
/*
Inicializa y muestra los mens del programa.

	Requiere: Recursos de tipo MENU en el fichero CdeCerca_4..rsrc
						Concretamente los recursos MENU n 128 y 129
	Recibe: 	nada
	Cambia:  	asigna valor a las globales e instala el men en la barra de mens
	Salida:   nada
*/
void MF_SetupMenus(void)
{
	
	/* Primero, leer los recursos de menu */
	gAppleMenu = GetMenu( kAppleMenuID );			
	gArchivoMenu = GetMenu( kArchivoMenuID );
	
	/* Nuevo: Aadir, al men Apple todo los que ya contiene... */
	/* La funcin AppendResMenu() aade a un men, los nombres de todos */
	/* los recursos del tipo especificado como parmetro. En este caso 'DRVR' */
	/* Qye resultan ser los items del men Apple, ya sean programas, documentos */
	/* etc... */
	AppendResMenu( gAppleMenu, 'DRVR' );
	
	InsertMenu(gAppleMenu, 0);
	InsertMenu(gArchivoMenu, 0);
	
	DrawMenuBar();
	
} /* Fin de MF_SetupMenus() */


	
/****************************************************************	*/
/* MF_AbreMiVentana		                                           	*/
/****************************************************************	*/
/*
	Abre la ventana (la nica) de nuestro programa. A diferencia de las anteriores
	versiones, en esta la ventana ha sido creada previamente empleando ResEdit
	y guardada en el fichero de recursos CdeCerca_4..rsrc.
	Durante la compilacin, los recursos de dicho fichero son copiados e
	integrados en la aplicacin resultante, quedando as en disposicin de ser
	empleados por la aplicacin.
	
	Requiere: Recurso WIND 128 (En CdeCerca_4..rsrc)
	Recibe: 	nada
	Que hace: Crea una ventana...
	Salida:  	void (nada)
*/
void MF_AbreMiVentana(void)
{
		
	/* 
	En vez de usar la funcin NewWindow(), empleamos la funcin
	GetNewWindow() que crea una ventana leyendo el formato de la misma
	contenido en un recurso WIND, dentro de los recursos de la aplicacin.
	
	GetNewWindow requiere los siguientes parmetros:
	
	GetNewWindow(short windowID, void *wStorage, WindowRef behind)
	Por el momento, el nico al que nos referiremos es:
	windowID: 	El nmero de recurso del tipo WIND definiendo la ventana.
	
	*/
	gMiVentana = GetNewWindow(kMiVentanaRsrcID, nil, (WindowPtr)-1L);
  
  if(gMiVentana == nil) 
  		ExitToShell();	/* Si la creacin de la ventana falla, 
  											posiblemente sea debido a falta de memoria libre
  											Lo ms aconsejable es salir de la aplicacin */
  	
} /* fin de MF_AbreMiVentana() */



/****************************************************************/
/* MF_EscribeTexto 		    																			*/ 
/****************************************************************/
/*
	Dibuja en nuestra ventana un texto.
		
	Recibe: 	nada
	Cambia:  	Dibuja en la ventana un texto.
	Salida:   nada
*/
void MF_EscribeTexto(void)
{
 			MoveTo(30,30);
 			DrawString("\pMacFormat - C de Cerca n 4");

}